# file: comprehensions.py
# author: Bob Muller
# 
# CS1101 Computer Science I
#
# Code illustrating list comprehensions.
#
import math

# isFactor : int * int -> bool
#
def isFactor(m, n): return n % m == 0
 
# isPrime : int -> bool
#
def isPrime(n):
  top = math.sqrt(n)
  def repeat(m):
    if m > top:
      return True
    elif isFactor(m, n):
      return False
    else:
      return repeat(m + 1)
  return repeat(2)

# primes : int -> int list
#
# The call primes(n) returns all of the prime numbers from 2 up to n.
# NB: This is a bad algorithm --- it's simple but inefficient.
#
def primes(n):
  ns = range(2, n + 1)
  return [ i for i in ns if isPrime(i) ]

# eratosthenes : int -> int list
#
# The call eratosthenes(n) does what primes(n) does. But it does so
# more efficiently.  This algorithm dates to ~300BCE.
#
def eratosthenes(n):
  ns = range(2, n + 1)
  def repeat(ms, primes):
    if ms == []:
      return primes
    else:
      first = ms[0]
      repeat([ i for i in ms if not(isFactor(first, i))], [first] + primes)
  return repeat(ns, [])
